<!DOCTYPE html>

<html lang="en" data-content_root="../../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>sagace.core.token_storage &#8212; sagace 2025 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=5ecbeea2" />
    <link rel="stylesheet" type="text/css" href="../../../_static/basic.css?v=b08954a9" />
    <link rel="stylesheet" type="text/css" href="../../../_static/alabaster.css?v=27fed22d" />
    <script src="../../../_static/documentation_options.js?v=cb975c41"></script>
    <script src="../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  

  
  

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for sagace.core.token_storage</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">--------------------------------------------------------------------------------------------------------------------</span>

<span class="sd">Descrição:</span>
<span class="sd">~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="sd">Este módulo define uma estrutura para gerenciamento de tokens de autenticação dentro do sistema SAGACE.</span>
<span class="sd">A interface `TokenStorage` estabelece um contrato para armazenamento e recuperação de tokens de forma desacoplada,</span>
<span class="sd">permitindo diferentes implementações conforme a necessidade do sistema.</span>

<span class="sd">Principais funcionalidades:</span>

<span class="sd">- Definição de uma interface para armazenamento seguro de tokens de autenticação.</span>
<span class="sd">- Permite a implementação de diferentes estratégias de persistência (memória, arquivos, banco de dados, etc.).</span>

<span class="sd">Princípios de Design Aplicados:</span>

<span class="sd">- **Single Responsibility Principle (SRP - SOLID)**: Cada classe tem uma única responsabilidade clara.</span>
<span class="sd">- **Open/Closed Principle (OCP - SOLID)**: A interface `TokenStorage` pode ser estendida sem modificar seu código-fonte.</span>
<span class="sd">- **Dependency Inversion Principle (DIP - SOLID)**: `TokenStorage` define uma abstração para armazenamento de tokens,</span>
<span class="sd">  permitindo que implementações concretas sejam facilmente substituídas.</span>

<span class="sd">Classes:</span>

<span class="sd">- ``TokenStorage``: Interface abstrata para armazenar e recuperar tokens.</span>

<span class="sd">Exemplo de uso:</span>

<span class="sd">.. code-block:: python</span>

<span class="sd">    from sagace.core import Token, TokenStorage</span>

<span class="sd">    class MemoryTokenStorage(TokenStorage):</span>
<span class="sd">        # Implementação de TokenStorage que armazena o token em memória.</span>
<span class="sd">        def __init__(self):</span>
<span class="sd">            self._token = None</span>

<span class="sd">        def save_token(self, token: Token):</span>
<span class="sd">            self._token = token</span>

<span class="sd">        def get_token(self) -&gt; Token:</span>
<span class="sd">            return self._token</span>

<span class="sd">    token_storage = MemoryTokenStorage()</span>
<span class="sd">    token = Token(</span>
<span class="sd">        base_url=&quot;https://api.sagace.online&quot;,</span>
<span class="sd">        access_token=&quot;abc123&quot;,</span>
<span class="sd">        application_name=&quot;Meu App&quot;,</span>
<span class="sd">        description=&quot;Token de acesso para integração.&quot;</span>
<span class="sd">    )</span>
<span class="sd">    token_storage.save_token(token)</span>
<span class="sd">    retrieved_token = token_storage.get_token()</span>
<span class="sd">    print(retrieved_token.get_auth_header())</span>

<span class="sd">Autor: Diego Yosiura</span>
<span class="sd">Última Atualização: 27/02/2025 16:22</span>
<span class="sd">Criado em: 27/02/2025 16:22</span>
<span class="sd">Copyright: (c) Ampere Consultoria Ltda</span>
<span class="sd">Projeto Original: sagace-v2-package</span>
<span class="sd">IDE: PyCharm</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span><span class="w"> </span><span class="nn">abc</span><span class="w"> </span><span class="kn">import</span> <span class="n">ABC</span><span class="p">,</span> <span class="n">abstractmethod</span>
<span class="kn">from</span><span class="w"> </span><span class="nn">.</span><span class="w"> </span><span class="kn">import</span> <span class="n">Token</span>


<div class="viewcode-block" id="TokenStorage">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.token_storage.TokenStorage">[docs]</a>
<span class="k">class</span><span class="w"> </span><span class="nc">TokenStorage</span><span class="p">(</span><span class="n">ABC</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Interface para armazenar e recuperar tokens de autenticação.</span>

<span class="sd">    Essa classe define um contrato para qualquer implementação de armazenamento de tokens,</span>
<span class="sd">    permitindo diferentes abordagens, como armazenamento em memória, arquivos ou banco de dados.</span>

<span class="sd">    Princípios aplicados:</span>
<span class="sd">    - **Dependency Inversion (D - SOLID)**: Permite substituir implementações sem modificar consumidores da interface.</span>
<span class="sd">    - **Open/Closed (O - SOLID)**: Pode ser estendida sem modificar o código existente.</span>
<span class="sd">    &quot;&quot;&quot;</span>

<div class="viewcode-block" id="TokenStorage.save_token">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.token_storage.TokenStorage.save_token">[docs]</a>
    <span class="nd">@abstractmethod</span>
    <span class="k">def</span><span class="w"> </span><span class="nf">save_token</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">token</span><span class="p">:</span> <span class="n">Token</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Armazena o token de autenticação.</span>

<span class="sd">        :param token: Token a ser armazenado.</span>
<span class="sd">        :type token: Token</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">pass</span></div>


<div class="viewcode-block" id="TokenStorage.get_token">
<a class="viewcode-back" href="../../../sagace.core.html#sagace.core.token_storage.TokenStorage.get_token">[docs]</a>
    <span class="nd">@abstractmethod</span>
    <span class="k">def</span><span class="w"> </span><span class="nf">get_token</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Token</span><span class="p">:</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Recupera o token armazenado.</span>

<span class="sd">        :return: Instância do token armazenado.</span>
<span class="sd">        :rtype: Token</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">pass</span></div>
</div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="Main">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">sagace</a></h1>









<search id="searchbox" style="display: none" role="search">
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" placeholder="Search"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</search>
<script>document.getElementById('searchbox').style.display = "block"</script><h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Conteúdo:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">sagace</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &#169;2025, Ampere Consultoria.
      
      |
      Powered by <a href="https://www.sphinx-doc.org/">Sphinx 8.2.1</a>
      &amp; <a href="https://alabaster.readthedocs.io">Alabaster 1.0.0</a>
      
    </div>

    

    
  </body>
</html>